# We don't want to use SCL since we are missing some dependencies 
# in SCL and we still support 1.8 for installer
%global scl_ruby /usr/bin/ruby

# set and uncomment all three to set alpha tag
#global alphatag RC1
#global dotalphatag .%{alphatag}
#global dashalphatag -%{alphatag}

Name:       fusor-installer
Epoch:      1
Version:    1.0.5
Release:    1%{?dotalphatag}%{?dist}
Summary:    Foreman-installer plugin that allows you to install Fusor
Group:      Applications/System
License:    GPLv3+ and ASL 2.0
URL:        http://theforeman.org
Source0:    %{name}-%{version}%{?dashalphatag}.tar.gz

BuildArch:  noarch

BuildRequires: asciidoc

Requires:   katello
Requires:   ntp
Requires:   rubygem-kafo >= 0.6.4
Requires:   git
Requires:   ovirt-puppet
Requires:   rubygem-ruby-ip
Requires:   iptables-services

%description
This is a Foreman-Installer plugin that allows you to install and configure
the Fusor Foreman plugin

%prep
%setup -q -n %{name}-%{version}%{?dashalphatag}

%build
#replace shebangs for SCL
%if %{?scl:1}%{!?scl:0}
  sed -ri '1sX(/usr/bin/ruby|/usr/bin/env ruby)X%{scl_ruby}X' bin/fusor-setup
%endif

# convert manpages
a2x -d manpage -f manpage fusor-installer.8.asciidoc
a2x -d manpage -f manpage fusor-setup.8.asciidoc

%install
install -d -m0755 %{buildroot}%{_datadir}/fusor-installer
cp -R hooks modules %{buildroot}%{_datadir}/fusor-installer
install -d -m0755 %{buildroot}%{_sbindir}
cp bin/fusor-installer %{buildroot}%{_sbindir}/fusor-installer
cp bin/fusor-setup %{buildroot}%{_sbindir}/fusor-setup
install -d -m0755 %{buildroot}%{_sysconfdir}/fusor-installer/
cp config/fusor-scenario.template %{buildroot}%{_sysconfdir}/fusor-installer/fusor-scenario.template
cp config/fusor-installer.yaml %{buildroot}%{_sysconfdir}/fusor-installer/fusor-installer.yaml
cp config/fusor-installer.answers.yaml %{buildroot}%{_sysconfdir}/fusor-installer/fusor-installer.answers.yaml
# manpages
%{__mkdir_p} %{buildroot}%{_mandir}/man8
cp -a fusor-installer.8 %{buildroot}/%{_mandir}/man8/
cp -a fusor-setup.8 %{buildroot}/%{_mandir}/man8/

%files
%defattr(-,root,root,-)
%doc LICENSE
%{_datadir}/fusor-installer/hooks/lib/base_wizard.rb
%{_datadir}/fusor-installer/hooks/lib/provisioning_wizard.rb
%{_datadir}/fusor-installer/hooks/pre_validations/10-gather_and_set_fusor_values.rb
%{_datadir}/fusor-installer/modules/
%config %attr(600, root, root) %{_sysconfdir}/fusor-installer/fusor-scenario.template
%config %attr(600, root, root) %{_sysconfdir}/fusor-installer/fusor-installer.yaml
%config(noreplace) %attr(600, root, root) %{_sysconfdir}/fusor-installer/fusor-installer.answers.yaml
%{_sbindir}/fusor-installer
%{_sbindir}/fusor-setup
%doc %{_mandir}/man8/fusor-installer.8*
%doc %{_mandir}/man8/fusor-setup.8*

%changelog
* Wed Aug 31 2016 David Gao <jinmaster923@gmail.com> 1.0.5-1
- 1369581 - fix output for "fusor-installer --list-scenarios"
  (dwhatley@redhat.com)
- 1369579 - re-register system upon user request (dwhatley@redhat.com)
- 1369434 - remove "do not configure networking" (#90) (derekwhatley@gmail.com)

* Wed Aug 24 2016 jesus m. rodriguez <jesusr@redhat.com> 1.0.4-1
- 1365509 - disable all except satellite repos. (jesusr@redhat.com)

* Thu Aug 18 2016 Jason Montleon <jmontleo@redhat.com> 1.0.3-1
- split dns range between discovery and managed hosts (jmontleo@redhat.com)

* Thu Aug 11 2016 jesus m. rodriguez <jesusr@redhat.com> 1.0.2-1
- user VersionTagger (jesusr@redhat.com)

* Thu Aug 11 2016 Jason Montleon <jmontleo@redhat.com> 1.0.1-12
- 1360411 - add iptables-services dependency to fusor-installer.spec
  (dwhatley@redhat.com)

* Wed Aug 10 2016 John Matthews <jwmatthews@gmail.com> 1.0.1-11
- 1365923 - config network & firewall more explicit (jesusr@redhat.com)

* Mon Aug 08 2016 John Matthews <jwmatthews@gmail.com> 1.0.1-10
- 1360335 - register host after network is up (jesusr@redhat.com)

* Fri Aug 05 2016 John Matthews <jwmatthews@gmail.com> 1.0.1-9
- 1261153 - switched ram check from dmidecode to free (dwhatley@redhat.com)
- 1361608 - fix misspelling of username in provisioning-wizard.rb
  (dwhatley@redhat.com)

* Fri Jul 29 2016 jesus m. rodriguez <jesusr@redhat.com> 1.0.1-8
- Add manpages for the two commands (#81) (jmrodri@gmail.com)
- Don't run validations if help is run. (#82) (jmontleo@redhat.com)
- 1261153 - Fixed mismatched comment on disk space check. (dwhatley@redhat.com)
- 1261153 - Added disk/ram/cpu validations to fusor-installer.  (dwhatley@redhat.com)

* Mon Jul 18 2016 John Matthews <jwmatthews@gmail.com> 1.0.1-7
- BZ#1356702: Exit for all help options (jmontleo@redhat.com)
- Remove BMC Options (jmontleo@redhat.com)
- BZ1356242 add netmask validation (jmontleo@redhat.com)
- BZ1356250 Fix to/from validations (jmontleo@redhat.com)

* Wed Jul 13 2016 Jason Montleon <jmontleo@redhat.com> 1.0.1-6
- improve valid_ip, use it before trying to use values (jmontleo@redhat.com)
- Added port 5000 for crane server to be accessed (dymurray@redhat.com)

* Tue Jul 05 2016 John Matthews <jwmatthews@gmail.com> 1.0.1-5
- 

* Tue Jul 05 2016 John Matthews <jwmatthews@gmail.com> 1.0.1-4
- 1309600 - Added foreman user access to /var/log/messages
  (jinmaster923@gmail.com)
- Added validation on DHCP gateway to not conflict with host IP
  (dymurray@redhat.com)

* Wed Jun 29 2016 John Matthews <jwmatthews@gmail.com> 1.0.1-3
- update display information and hide password from promt for the 'Register
  Host' option (jkim@jkimdt.usersys.redhat.com)
- 1277277 - Changed "DHCP Network address" >> "DHCP network address" to align
  with capitalization rules. (dwhatley@redhat.com)
- prevent foreman-installer using fusor-installer config dir in dev
  (jmontleo@redhat.com)
- update the comment in the register host prompt to add the word 'do'
  (jkim@jkimdt.usersys.redhat.com)
- add option to register system for updates with CDN
  (jkim@jkimdt.usersys.redhat.com)
- Added setfacl commands for devel environment. (jinmaster923@gmail.com)

* Thu Jun 16 2016 Jason Montleon <jmontleo@redhat.com> 1.0.1-2
- Add non-interactive option (jmontleo@redhat.com)
- Hide ugly output and provide readable status (jmontleo@redhat.com)

* Tue Jun 14 2016 Jason Montleon <jmontleo@redhat.com> 1.0.1-1
- Refactored Installer (jmontleo@redhat.com)

* Fri Jun 03 2016 Jason Montleon <jmontleo@redhat.com> 1.0.0-3
- Remove forced puppetclass import (jmontleo@redhat.com)
- wait for rails to really be running before we try to do stuff
  (jmontleo@redhat.com)
- Remove unnecessary tasks (jmontleo@redhat.com)
- make the name match the id we're using for self hosted ptable lookup
  (jmontleo@redhat.com)

* Thu May 19 2016 Jason Montleon <jmontleo@redhat.com> 1.0.0-2
- Update the puppet ovirt module version as it was bumped for GA release
  (jmontleo@redhat.com)

* Tue May 17 2016 Jason Montleon <jmontleo@redhat.com> 1.0.0-1
- bump package version to 1.0.0 (jmontleo@redhat.com)
- add ptable for self-hosted (fabian@fabianism.us)

* Wed May 11 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-22
- nsure puppet classes are imported into environment (jmontleo@redhat.com)

* Fri May 06 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-21
- initial changes to support working with sat 6.2 (jmontleo@redhat.com)

* Thu Apr 28 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-20
- initial changes to support working with sat 6.2 (jmontleo@redhat.com)

* Thu Apr 28 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-19
- initial changes to support working with sat 6.2 (jmontleo@redhat.com)

* Tue Apr 19 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-18
- initial changes to support working with sat 6.2 (jmontleo@redhat.com)

* Fri Apr 15 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-17
- initial changes to support working with sat 6.2 (jmontleo@redhat.com)

* Thu Apr 14 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-16
- initial changes to support working with sat 6.2 (jmontleo@redhat.com)
- 1315470: do not remap cancel exit code. (jesusr@redhat.com)
- Make sure settings that must be IP's are IP's and not hostnames
  (jmontleo@redhat.com)

* Tue Mar 29 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-15
- initial changes to support working with sat 6.2 (jmontleo@redhat.com)

* Mon Mar 28 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-14
- initial changes to support working with sat 6.2 (jmontleo@redhat.com)

* Wed Mar 23 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-13
- additional changes to support working with sat 6.2 (jmontleo@redhat.com)

* Thu Mar 10 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-12
- suggest a proper gateway for the net regardless of where the host gateway is
  and compute dhcp range using it (jmontleo@redhat.com)

* Mon Mar 07 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-11
- additional satellite-6.2 fixes (jmontleo@redhat.com)

* Fri Mar 04 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-10
- fix foreman_base_url param (jmontleo@redhat.com)

* Fri Mar 04 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-9
- remove host_seeder.rb from rpm spec

* Fri Mar 04 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-8
- more satellite 6.2 updates (jmontleo@redhat.com)

* Fri Mar 04 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-7
- update answers for 6.2 (jmontleo@redhat.com)
- fix accidental indentation of capsule section (jmontleo@redhat.com)

* Fri Mar 04 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-6
- update fusor-installer.yaml for satellite 6.2 (jmontleo@redhat.com)

* Thu Mar 03 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-5
- initial changes to support working with sat 6.2 (jmontleo@redhat.com)

* Thu Mar 03 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-4
- more sat 6.2 fixes (jmontleo@redhat.com)

* Thu Mar 03 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-3
- more satellite 6.2 fixes (jmontleo@redhat.com)

* Thu Mar 03 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-2
- fix rpm spec (jmontleo@redhat.com)

* Thu Mar 03 2016 Jason Montleon <jmontleo@redhat.com> 0.0.15-1
- initial changes to support working with sat 6.2 (jmontleo@redhat.com)

* Wed Mar 02 2016 Jason Montleon <jmontleo@redhat.com> 0.0.14-33
- require katello instead of katello-installer since katello-installer is
  deprecated in sat 6.2 (jmontleo@redhat.com)

* Mon Feb 29 2016 Jason Montleon <jmontleo@redhat.com> 0.0.14-32
- make sure @base_url gets set properly so the installer can proceed and fix
  typo in @to (jmontleo@redhat.com)

* Thu Feb 25 2016 Jason Montleon <jmontleo@redhat.com> 0.0.14-31
- Don't set base_url until we can set it to something useful
  (jmontleo@redhat.com)

* Thu Feb 25 2016 Jason Montleon <jmontleo@redhat.com> 0.0.14-30
- fix some validation and make intelligent suggestions for gateway, network,
  and dhp range (jmontleo@redhat.com)

* Fri Feb 19 2016 Jason Montleon <jmontleo@redhat.com> 0.0.14-29
- fix redirect for ntpdate (jmontleo@redhat.com)

* Fri Feb 19 2016 Jason Montleon <jmontleo@redhat.com> 0.0.14-28
- sync time immediately so certs are not created incorrectly
  (jmontleo@redhat.com)
- match RHEL 7.2 timedatectl output correctly (jmontleo@redhat.com)
- Make Satellite server an NTP host (fabian@fabianism.us)
- Remove whitespace in config/fusor-devel-installer.yaml
  (daviddavis@redhat.com)
- Creating a new development environment (daviddavis@redhat.com)

* Fri Jan 22 2016 John Matthews <jwmatthews@gmail.com> 0.0.14-27
- update Timezone to Time zone (johnkim76@gmail.com)

* Thu Jan 21 2016 Jason Montleon <jmontleo@redhat.com> 0.0.14-26
- offer a forwarder if ip address is nil and make sure we don't match similar
  ip addresses (jmontleo@redhat.com)

* Mon Jan 18 2016 Jason Montleon <jmontleo@redhat.com> 0.0.14-25
- Fixes 1295491: fusor-installer NTP check may leave system with a broken
  /etc/resolv.conf (jmontleo@redhat.com)

* Thu Jan 14 2016 Jason Montleon <jmontleo@redhat.com> 0.0.14-24
- 1277277 - Update to properly lower case prompts (johnkim76@gmail.com)

* Fri Dec 11 2015 Jason Montleon <jmontleo@redhat.com> 0.0.14-23
- 1278087 - Change exit code for invalid NTP host (johnkim76@gmail.com)
- 1277277 - Modify user prompts (johnkim76@gmail.com)

* Mon Nov 02 2015 John Matthews <jwmatthews@gmail.com> 0.0.14-22
- Update to give user option to continue if NTP check failed
  (jkim@jkimdt.usersys.redhat.com)
- Restore the orig config files (jkim@jkimdt.usersys.redhat.com)
- BZ1263435 - NTP check after network setup fix
  (jkim@jkimdt.usersys.redhat.com)
- 1263757 - Alignment of fusor-installer BZ Fix
  (jkim@jkimdt.usersys.redhat.com)
- Update the error message for Network Mask (jkim@jkimdt.usersys.redhat.com)
- Update the validation with other input parameters
  (jkim@jkimdt.usersys.redhat.com)
- Update IP validation (jkim@jkimdt.usersys.redhat.com)
- use rhel pool instead of centos (jmontleo@redhat.com)

* Thu Aug 20 2015 Jason Montleon <jmontleo@redhat.com> 0.0.14-21
- use rhel pool instead of centos (jmontleo@redhat.com)

* Mon Aug 10 2015 John Matthews <jwmatthews@gmail.com> 0.0.14-20
- 1197861 - change color back to green/red for prompts #1 and #20
  (jkim@dt1.example.com)
- Addresses BZ 1197861 https://bugzilla.redhat.com/show_bug.cgi?id=1197861
  (jkim@dt1.example.com)

* Wed Aug 05 2015 John Matthews <jwmatthews@gmail.com> 0.0.14-19
- installer wizard: add support for configuring BMC feature
  (bbuckingham@redhat.com)
- installer spec: adding host_seeder.rb (bbuckingham@redhat.com)

* Thu Jul 30 2015 John Matthews <jwmatthews@gmail.com> 0.0.14-18
- Use a register hook that exists in older kafo too (sherr@redhat.com)

* Wed Jul 29 2015 John Matthews <jwmatthews@gmail.com> 0.0.14-17
- Merge pull request #27 from sdherr/reset (jwmatthews@gmail.com)
- Merge pull request #26 from johnkim76/seed_timeout (jwmatthews@gmail.com)
- seeding: removing usage of 'base_hostgroup' setting (bbuckingham@redhat.com)
- fusor-installer --reset needs to clear puppet environments too
  (sherr@redhat.com)
- Increase timeout value for seed provisioning data request
  (jkim@jkimdt.usersys.redhat.com)

* Wed Jul 08 2015 Jason Montleon <jmontleo@redhat.com> 0.0.14-16
- Add additional logic for configuring hostnames (jmontleo@redhat.com)

* Wed Jul 08 2015 Jason Montleon <jmontleo@redhat.com> 0.0.14-15
- add new file to rpm spec (jmontleo@redhat.com)

* Wed Jul 08 2015 Jason Montleon <jmontleo@redhat.com> 0.0.14-14
- add Hostname configuration to provisioning wizard (jmontleo@redhat.com)

* Thu Jun 18 2015 John Matthews <jwmatthews@gmail.com> 0.0.14-13
- update to set sleep time in create_with_retries to 30
  (jkim@jkimdt.usersys.redhat.com)
- modify the katello_search_or_ensure's create call to check for the 422 error
  and loop if needed. (jkim@jkimdt.usersys.redhat.com)

* Fri Jun 12 2015 Jason Montleon <jmontleo@redhat.com> 0.0.14-12
- add additional fw ports (jmontleo@redhat.com)

* Fri Jun 12 2015 Jason Montleon <jmontleo@redhat.com> 0.0.14-11
- add fw missing ports (jmontleo@redhat.com)

* Thu Jun 11 2015 Jason Montleon <jmontleo@redhat.com> 0.0.14-10
- second attempt at creating persistent and consistent firewall policy on
  install. (jmontleo@redhat.com)

* Wed Jun 10 2015 Jason Montleon <jmontleo@redhat.com> 0.0.14-9
- package new fusor_fw*.pp files (jmontleo@redhat.com)

* Tue Jun 09 2015 Jason Montleon <jmontleo@redhat.com> 0.0.14-8
- make firewall persistent (jmontleo@redhat.com)

* Mon Jun 08 2015 Jason Montleon <jmontleo@redhat.com> 0.0.14-7
- add unpacked file 

* Mon Jun 08 2015 Jason Montleon <jmontleo@redhat.com> 0.0.14-6
- create host before doing a puppet run to prevent 400 error
  (jmontleo@redhat.com)

* Fri Jun 05 2015 John Matthews <jwmatthews@gmail.com> 0.0.14-5
- don't try to sync non-existent plugins (jmontleo@redhat.com)

* Thu Jun 04 2015 John Matthews <jwmatthews@gmail.com> 0.0.14-4
- update the text ui to remove the configuration shown at the top of the
  screen. (jkim@jkimdt.usersys.redhat.com)

* Wed Jun 03 2015 John Matthews <jwmatthews@gmail.com> 0.0.14-3
- modified to print the default, and user entered values next to the promt for
  easier reaing during installation (jkim@jkimdt.usersys.redhat.com)

* Wed Apr 22 2015 John Matthews <jwmatthews@gmail.com> 0.0.14-2
- Merge remote-tracking branch 'upstream/master' into RHCI-6
  (jwmatthews@gmail.com)
- Automatic commit of package [fusor-installer] minor release [0.0.13-2].
  (jmontleo@redhat.com)
- add rel-eng files (jmontleo@redhat.com)

* Thu Apr 09 2015 John Matthews <jwmatthews@gmail.com> 0.0.14-1
- answers: add gutterball plugin (bbuckingham@redhat.com)

* Tue Apr 07 2015 Jason Montleon <jmontleo@redhat.com> 0.0.13-2
- new package built with tito

* Tue Mar 31 2015 John Matthews <jwmatthews@gmail.com> 0.0.13-1
- seeding: fix the hostgroup seeding for 'Fusor Base' (bbuckingham@redhat.com)

* Tue Mar 31 2015 John Matthews <jwmatthews@gmail.com> 0.0.12-1
- Merge pull request #6 from bbuckingham/seeding_updates (jwmatthews@gmail.com)
- seeding: updates based on fusor-server updates for hostgroups
  (bbuckingham@redhat.com)

* Thu Mar 19 2015 John Matthews <jwmatthews@gmail.com> 0.0.11-1
- Updates from testing with Sat 6.1 3.11.1 compose  - Add stanza for gutterball
  config  - Hard code parameters for kernel/initrd of foreman plugin discovery
  since puppet params have been deleted  - Remove explicit enable of
  foreman_plugin_discovery (jwmatthews@gmail.com)

* Tue Mar 10 2015 John Matthews <jwmatthews@gmail.com> 0.0.10-1
- Comment out blocks in ks_snippets which break provisioning. Syntax issues
  with usage of:   @host.network_query   def custom_deployment_repositories
  (jwmatthews@gmail.com)

* Tue Mar 03 2015 John Matthews <jwmatthews@gmail.com> 0.0.9-1
- Remove extra https:// in PXE Template for specifying foreman URL
  (jwmatthews@gmail.com)

* Tue Mar 03 2015 John Matthews <jwmatthews@gmail.com> 0.0.8-1
- Updates for discovery to work with foreman-discovery-image-2.1.0
  (jwmatthews@gmail.com)
- spec - remove Requires on foreman_api (bbuckingham@redhat.com)
- spec - removing hack that required puppet 3.7.3 (bbuckingham@redhat.com)
- seeding: update use foremao's content management (bbuckingham@redhat.com)
- seeding: update to use apipie bindings vs foreman api
  (bbuckingham@redhat.com)

* Fri Feb 20 2015 John Matthews <jwmatthews@gmail.com> 0.0.7-1
- Disable the download of discovery images. (jwmatthews@gmail.com)

* Thu Feb 12 2015 John Matthews <jwmatthews@gmail.com> 0.0.6-1
- Fix for when /etc/puppet/environments/production/ is missing
  (jwmatthews@gmail.com)

* Thu Feb 12 2015 John Matthews <jwmatthews@gmail.com> 0.0.5-1
- Adding requires for ovirt-puppet (jwmatthews@gmail.com)

* Thu Feb 12 2015 John Matthews <jwmatthews@gmail.com> 0.0.4-1
- Removed requirement of puppet 3.7.3 (jwmatthews@gmail.com)
- foreman discovery: updates to support discovery (bbuckingham@redhat.com)
- ovirt - initial seeding to support ovirt (bbuckingham@redhat.com)
- remove partitioning table seed that was specific to openstack with staypuft
  (bbuckingham@redhat.com)

* Tue Feb 03 2015 John Matthews <jwmatthews@gmail.com> 0.0.3-1
- Adding a HACK workaround to force puppet to be 3.7.3 Needed to address a
  known issue with puppet 3.7.4 (jwmatthews@gmail.com)

* Mon Jan 19 2015 John Matthews <jwmatthews@gmail.com> 0.0.2-1
- new package built with tito



